//przykladowa implementacja sterty w tablicy
//oraz sortowania heapsort

//UWAGA! Dla prostoty kodu przyjeto, ze
//tablice zaczynaja sie na polu o indeksie 1

#include<cstdio>
#include<cstdlib>
#include<iostream>
#include<iomanip>

const int maxsize = 8;
int heapsize = 0;

using namespace std;

void swap(int *t, int i, int j){
	int pom=t[i];
     t[i]=t[j];
	t[j]=pom;
}

void upheap(int *t, int i){
	while(i>1)
		if(t[i]>t[i/2]){
			swap(t,i,i/2);
			i=i/2;
			}
		else
			i=1;
}

//N - rozmiar sterty gdzie t[N] to ostatni element
//    t[1] - element na wierzcholku sterty

void downheap(int *t,int i, int N){
	int j=2*i;
	while(j <=N){
		if((t[j]<t[j+1])&& j+1<=N)
			j++;
		if(t[i]<t[j]){
			swap(t,i,j);
			i=j;
			j=2*i;
		}
		else
			j=N+1;
	}
}

void heapsort(int *t,int N){
	for(int k=N/2;k>=1;k--)
		downheap(t,k,N);
	while(N>1){
		swap(t,1,N);
		N--;
		downheap(t,1,N);
	}
}

void slower_heapsort(int *t, int N){
	for(int k=2;k<=N;k++)
		upheap(t,k);
     while(N>1){
		swap(t,1,N);
		N--;
		downheap(t,1,N);
	}
}

//implementacja kolejki priorytetowej na stercie

void insert(int *t, int elem){
	if(heapsize>=maxsize)
		return;
	heapsize++;
	t[heapsize]=elem;
	upheap(t,heapsize);
}

int delMax(int *t){
	int pom=t[1];
	t[1]=t[heapsize];
	heapsize--;
	downheap(t,1,heapsize);
	return pom;
}

int main(void){
int t[maxsize+1]={0,3,4,5,1,4,9,8,13};
cout<<endl;
for(int i=1;i<=maxsize;i++)
	cout<<t[i]<<", ";
slower_heapsort(t,8);
cout<<endl;
for(int i=1;i<=maxsize;i++)
	cout<<t[i]<<", ";
cout<<endl<<flush;

system("read -p \"Press [Enter]\" "); //Linux
//system("pause"); //DOS
return 1;
}